/*
 * Beangle, Agile Java/Scala Development Scaffold and Toolkit
 *
 * Copyright (c) 2005-2012, Beangle Software.
 *
 * Beangle is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Beangle is distributed in the hope that it will be useful.
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Beangle.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.beangle.commons.entity.pojo;

import java.io.Serializable;
import java.util.Date;

import org.beangle.commons.entity.Entity;

/**
 * <p>
 * TimeEntity interface.
 * </p>
 * 
 * @author chaostone
 * @version $Id: $
 */
public interface TimeEntity<T extends Serializable> extends Entity<T> {

  /**
   * Returns Created at.
   */
  Date getCreatedAt();

  /**
   * <p>
   * setCreatedAt.
   * </p>
   * 
   * @param createdAt a {@link java.util.Date} object.
   */
  void setCreatedAt(Date createdAt);

  /**
   * <p>
   * getUpdatedAt.
   * </p>
   * 
   * @return a {@link java.util.Date} object.
   */
  Date getUpdatedAt();

  /**
   * <p>
   * setUpdatedAt.
   * </p>
   * 
   * @param updatedAt a {@link java.util.Date} object.
   */
  void setUpdatedAt(Date updatedAt);
}
